/*******************************************************************************
 * Copyright (c) 2006 - 2012 CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     CEA LIST - initial API and implementation
 *******************************************************************************/

package org.eclipse.papyrus.cpp.codegen.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.papyrus.cpp.codegen.Activator;


public class CppCodeGenPreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(CppCodeGenConstants.P_HEADER_SUFFIX, "h");
		store.setDefault(CppCodeGenConstants.P_IMPLEM_SUFFIX, "cpp");
		store.setDefault(CppCodeGenConstants.P_OUT_INOUT_OP, "*");

		// Default value for P_COMMENT_HEADER
		String NL = System.getProperties().getProperty("line.separator");
		String defaultValue = "" + "// --------------------------------------------------------" + NL + "// Code generated by Papyrus C++" + NL + "// --------------------------------------------------------" + NL + NL;
		store.setDefault(CppCodeGenConstants.P_COMMENT_HEADER, defaultValue);
	}
}
